PUBLIC oCapWin
oCapWin = CREATEOBJECT("CaptureWindow")
oCapWin.StartPreview
* end of main

#DEFINE WS_CHILD   0x40000000
#DEFINE WS_VISIBLE 0x10000000
#DEFINE WS_CAPTION 0x00C00000
#DEFINE WS_SYSMENU 0x00080000
#DEFINE WM_CAP_START  0x0400
#DEFINE WM_CAP_DRIVER_CONNECT (WM_CAP_START+10)
#DEFINE WM_CAP_DRIVER_DISCONNECT (WM_CAP_START+11)
#DEFINE WM_CAP_SET_PREVIEW (WM_CAP_START+50)
#DEFINE WM_CAP_SET_PREVIEWRATE (WM_CAP_START+52)
#DEFINE WM_CAP_FILE_SAVEDIB (WM_CAP_START+25)
#DEFINE WM_CAP_GRAB_FRAME (WM_CAP_START+60)
#DEFINE WM_CAP_FILE_SET_CAPTURE_FILE (WM_CAP_START+20)
#DEFINE WM_CAP_SEQUENCE (WM_CAP_START+62)
#DEFINE WM_CAP_SET_SEQUENCE_SETUP (WM_CAP_START+64)
#DEFINE WM_CAP_GET_SEQUENCE_SETUP (WM_CAP_START+65)
#DEFINE WM_CAP_DLG_VIDEOFORMAT (WM_CAP_START+41)
#DEFINE WM_CAP_GET_VIDEOFORMAT (WM_CAP_START+44)
#DEFINE BITMAPINFOHEADER_SIZE 40

DEFINE CLASS CaptureWindow As Custom
	hCapture=0
	capWidth=0
	capHeight=0

PROCEDURE Init(hParent, nLeft, nTop)
	DECLARE INTEGER capCreateCaptureWindow IN avicap32;
		STRING lpszWindowName, LONG dwStyle,;
		INTEGER x, INTEGER y,;
		INTEGER nWidth, INTEGER nHeight,;
		INTEGER hParent, INTEGER nID

	DECLARE INTEGER DestroyWindow IN user32 INTEGER hWnd

	THIS.hCapture = capCreateCaptureWindow(;
		"VFP Capture Window",;
		BITOR(WS_CHILD,WS_VISIBLE),;
		nLeft,nTop, 320,240, hParent, 0)

	THIS.msg(THIS.hCapture, WM_CAP_DRIVER_CONNECT, 0,0)

PROCEDURE Destroy
	THIS.msg(THIS.hCapture, WM_CAP_DRIVER_DISCONNECT, 0,0)
	= DestroyWindow(THIS.hCapture)

PROCEDURE StartPreview
	THIS.msg(THIS.hCapture, WM_CAP_SET_PREVIEWRATE, 30,0)
	THIS.msg(THIS.hCapture, WM_CAP_SET_PREVIEW, 1,0)

PROCEDURE StopPreview
	THIS.msg(THIS.hCapture, WM_CAP_SET_PREVIEW, 0,0)

PROCEDURE GrabFrame
	THIS.msg(THIS.hCapture, WM_CAP_GRAB_FRAME, 0,0)

PROCEDURE SaveToDib(cFilename)
	THIS.msg1(THIS.hCapture, WM_CAP_FILE_SAVEDIB,;
		0, @cFilename)

PROCEDURE SaveToAvi(cFilename, nSeconds)
* target AVI file name, number of seconds to capture
	LOCAL cBuffer

	* allocating string buffer of CAPTUREPARAMS size
	cBuffer=REPLICATE(CHR(0), 96)

	* populating string buffer with CAPTUREPARMS data
	THIS.msg1(THIS.hCapture, WM_CAP_GET_SEQUENCE_SETUP,;
		LEN(cBuffer), @cBuffer)

	* setting fLimitEnabled to True and wTimeLimit to number of seconds
	* note that offset for FoxPro string starts with 1
	cBuffer = STUFF(cBuffer, 53, 4, num2dword(1))
	cBuffer = STUFF(cBuffer, 57, 4, num2dword(nSeconds))

	* sending modified CAPTUREPARMS back to the capture window
	THIS.msg1(THIS.hCapture, WM_CAP_SET_SEQUENCE_SETUP,;
		LEN(cBuffer), @cBuffer)
	
	* setting AVI file name
	THIS.msg1(THIS.hCapture, WM_CAP_FILE_SET_CAPTURE_FILE,;
		0, @cFilename)

	* starting the capture - will stop by itself after nSeconds
	THIS.msg(THIS.hCapture, WM_CAP_SEQUENCE, 0,0)

PROCEDURE VideoFormatDlg
	THIS.msg(THIS.hCapture, WM_CAP_DLG_VIDEOFORMAT, 0,0)

PROCEDURE GetVideoFormat
	LOCAL cBuffer, nBufsize

	nBufsize=4096
	cBuffer = PADR(num2dword(BITMAPINFOHEADER_SIZE),;
		nBufsize, CHR(0))

	THIS.msg1(THIS.hCapture, WM_CAP_GET_VIDEOFORMAT,;
		nBufsize, @cBuffer)

	THIS.capWidth = buf2num(SUBSTR(cBuffer, 5,4))
	THIS.capHeight = buf2num(SUBSTR(cBuffer, 9,4))

PROCEDURE msg(hCapture, cMessage, wParam, lParam)
	DECLARE INTEGER SendMessage IN user32;
		INTEGER hWnd, INTEGER Msg,;
		INTEGER wParam, INTEGER lParam
	= SendMessage(m.hCapture, cMessage, wParam, lParam)

PROCEDURE msg1(hCapture, cMessage, wParam, lParam)
	DECLARE INTEGER SendMessage IN user32;
		INTEGER hWnd, INTEGER Msg,;
		INTEGER wParam, STRING @lParam
	= SendMessage(m.hCapture, cMessage, wParam, @lParam)

ENDDEFINE

FUNCTION num2dword(lnValue)
#DEFINE m0  0x100
#DEFINE m1  0x10000
#DEFINE m2  0x1000000
	LOCAL b0, b1, b2, b3
	b3 = Int(lnValue/m2)
	b2 = Int((lnValue - b3*m2)/m1)
	b1 = Int((lnValue - b3*m2 - b2*m1)/m0)
	b0 = Mod(lnValue, m0)
RETURN Chr(b0)+Chr(b1)+Chr(b2)+Chr(b3)

FUNCTION buf2num(lcBuffer)
RETURN Asc(SUBSTR(lcBuffer, 1,1)) + ;
	BitLShift(Asc(SUBSTR(lcBuffer, 2,1)),  8) +;
	BitLShift(Asc(SUBSTR(lcBuffer, 3,1)), 16) +;
	BitLShift(Asc(SUBSTR(lcBuffer, 4,1)), 24)
